package com.maileon.api.account;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;
import java.io.Serializable;

/**
 * The wrapper class for a Maileon account placeholder. This class wraps the XML structure.
 *
 * @author Marcus Beckerle | XQueue GmbH | <a href="marcus.beckerle@xqueue.com">marcus.beckerle@xqueue.com</a>
 */
@XmlType(propOrder = {"key", "value"})
public class AccountPlaceholder implements Serializable {

    protected String key;

    protected String value;

    public AccountPlaceholder() {}

    public AccountPlaceholder(String key, String value) {
        this.key = key;
        this.value = value;
    }

    /**
     * @return the key
     */
    @XmlElement(name="key", required = true)
    public String getKey() {
        return key;
    }

    /**
     * @param key the key to set
     */
    public void setKey(String key) {
        this.key = key;
    }

    /**
     * @return the value
     */
    @XmlElement(name="value", required = true)
    public String getValue() {
        return value;
    }

    /**
     * @param value the value to set
     */
    public void setValue(String value) {
        this.value = value;
    }
}
