/**
 * xqueue.com
 */
package com.maileon.api.mailings.checks;

import java.io.Serializable;
import java.util.Date;
import java.util.List;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

/**
 * Result of MessageSize check
 */
@XmlRootElement(name="MessageSizeCheck")
@XmlType(propOrder={"mailingId", "timestamp", "state", "totalEmailSize",
    "msgSize", "msgSizeLimit", "msgSizeLimitExceeded", "attachments",
    "attachmentSizeLimit", "inlineImages", "headers", "html", "text"})
public class MessageSizeCheckResult implements Serializable {

    private long mailingId;

    private Date timestamp;

    private String state;

    private long totalEmailSize;

    private long msgSize;

    private long msgSizeLimit;

    private boolean msgSizeLimitExceeded;

    private List<MessageSizeAttachmentResultAPI> attachments;

    private long attachmentSizeLimit;

    private List<MessageSizeInlineImagesResultAPI> inlineImages;

    private long headers;

    private long html;

    private long text;

    /**
     * @return the totalEmailSize
     */
    @XmlElement(name="emailSize")
    public long getTotalEmailSize() {
        return totalEmailSize;
    }

    /**
     * @param totalEmailSize the totalEmailSize to set
     */
    public void setTotalEmailSize(long totalEmailSize) {
        this.totalEmailSize = totalEmailSize;
    }

    /**
     * @return the msgSize
     */
    @XmlElement(name="messageSize")
    public long getMsgSize() {
        return msgSize;
    }

    /**
     * @param msgSize the msgSize to set
     */
    public void setMsgSize(long msgSize) {
        this.msgSize = msgSize;
    }

    /**
     * @return the msgSizeLimit
     */
    @XmlElement(name="messageSizeLimit")
    public long getMsgSizeLimit() {
        return msgSizeLimit;
    }

    /**
     * @param msgSizeLimit the msgSizeLimit to set
     */
    public void setMsgSizeLimit(long msgSizeLimit) {
        this.msgSizeLimit = msgSizeLimit;
    }

    /**
     * @return the msgSizeLimitExceeded
     */
    @XmlElement(name="sizeExceeded")
    public boolean isMsgSizeLimitExceeded() {
        return msgSizeLimitExceeded;
    }

    /**
     * @param msgSizeLimitExceeded the msgSizeLimitExceeded to set
     */
    public void setMsgSizeLimitExceeded(boolean msgSizeLimitExceeded) {
        this.msgSizeLimitExceeded = msgSizeLimitExceeded;
    }

    /**
     * @return the attachmentSizeLimit
     */
    @XmlElement
    public long getAttachmentSizeLimit() {
        return attachmentSizeLimit;
    }

    /**
     * @param attachmentSizeLimit the attachmentSizeLimit to set
     */
    public void setAttachmentSizeLimit(long attachmentSizeLimit) {
        this.attachmentSizeLimit = attachmentSizeLimit;
    }

    /**
     * @return the headers
     */
    @XmlElement
    public long getHeaders() {
        return headers;
    }

    /**
     * @param headers the headers to set
     */
    public void setHeaders(long headers) {
        this.headers = headers;
    }

    /**
     * @return the html
     */
    @XmlElement
    public long getHtml() {
        return html;
    }

    /**
     * @param html the html to set
     */
    public void setHtml(long html) {
        this.html = html;
    }

    /**
     * @return the text
     */
    @XmlElement
    public long getText() {
        return text;
    }

    /**
     * @param text the text to set
     */
    public void setText(long text) {
        this.text = text;
    }

    /**
     * @return the attachments
     */
    @XmlElementWrapper(name="attachments")
    @XmlElement(name="item", type=MessageSizeAttachmentResultAPI.class)
    public List<MessageSizeAttachmentResultAPI> getAttachments() {
        return attachments;
    }

    /**
     * @param attachments the attachments to set
     */
    public void setAttachments(List<MessageSizeAttachmentResultAPI> attachments) {
        this.attachments = attachments;
    }

    /**
     * @return the inlineImages
     */
    @XmlElementWrapper(name="inlineImages")
    @XmlElement(name="item", type=MessageSizeInlineImagesResultAPI.class)
    public List<MessageSizeInlineImagesResultAPI> getInlineImages() {
        return inlineImages;
    }

    /**
     * @param inlineImages the inlineImages to set
     */
    public void setInlineImages(List<MessageSizeInlineImagesResultAPI> inlineImages) {
        this.inlineImages = inlineImages;
    }

    @XmlElement
    public long getMailingId() {
        return mailingId;
    }

    public void setMailingId(long mailingId) {
        this.mailingId = mailingId;
    }

    @XmlElement
    public Date getTimestamp() {
        return timestamp;
    }

    public void setTimestamp(Date timestamp) {
        this.timestamp = timestamp;
    }

    @XmlElement
    public String getState() {
        return state;
    }

    public void setState(String state) {
        this.state = state;
    }

    @Override
    public String toString() {
        String ret = "mailingId: " + mailingId + ", state:" + state + ", timestamp: " + timestamp
                + ", attachmentSizeLimit: " + attachmentSizeLimit + ", headers: " + headers
                + ", html: " + html + ", msgSize: " + msgSize + ", msgSizeLimit: " + msgSizeLimit
                + ", msgSizeLimitExceeded: " + msgSizeLimitExceeded
                + ", text: " + text + ", totalEmailSize: " + totalEmailSize;
        return ret;
    }
}
