package com.maileon.api.mailings.checks;

import com.maileon.api.mailings.Personalization;
import java.io.Serializable;
import java.util.Date;
import java.util.List;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

/**
 * Result for Personalization Check
 */
@XmlRootElement(name="PersonalizationCheck")
@XmlType(propOrder={"mailingId", "timestamp", "state", "targetGroupSize", "misses", "subjectPersonalizations",
    "fromAliasPersonalizations", "recipientAliasPersonalizations", "htmlPersonalizations", "textPersonalizations"})
public class PersonalizationCheckResult implements Serializable {

    private long mailingId;

    private Date timestamp;

    private String state;

    private int targetGroupSize;

    private int misses;

    private List<PersonalizationInformation> subjectPersonalizations;

    private List<PersonalizationInformation> fromAliasPersonalizations;

    private List<PersonalizationInformation> recipientAliasPersonalizations;

    private List<PersonalizationInformation> htmlPersonalizations;

    private List<PersonalizationInformation> textPersonalizations;

    @Override
    public String toString() {
        String s = "mailingId: " + mailingId
                + ", timestamp: " + timestamp
                + ", state: " + state
                + ", targetGroupSize: " + targetGroupSize
                + ", misses: " + misses;
        return s;
    }

    @XmlElement
    public int getTargetGroupSize() {
        return targetGroupSize;
    }

    public void setTargetGroupSize(int targetGroupSize) {
        this.targetGroupSize = targetGroupSize;
    }

    @XmlElement
    public int getMisses() {
        return misses;
    }

    public void setMisses(int misses) {
        this.misses = misses;
    }

    @XmlElementWrapper(name="subjectPersonalizations")
    @XmlElement(name = "item", type=Personalization.class)
    public List<PersonalizationInformation> getSubjectPersonalizations() {
        return subjectPersonalizations;
    }

    public void setSubjectPersonalizations(List<PersonalizationInformation> subjectPersonalizations) {
        this.subjectPersonalizations = subjectPersonalizations;
    }

    @XmlElementWrapper(name="fromAliasPersonalizations")
    @XmlElement(name = "item", type=Personalization.class)
    public List<PersonalizationInformation> getFromAliasPersonalizations() {
        return fromAliasPersonalizations;
    }

    public void setFromAliasPersonalizations(List<PersonalizationInformation> fromAliasPersonalizations) {
        this.fromAliasPersonalizations = fromAliasPersonalizations;
    }

    @XmlElementWrapper(name="recipientAliasPersonalizations")
    @XmlElement(name = "item", type=Personalization.class)
    public List<PersonalizationInformation> getRecipientAliasPersonalizations() {
        return recipientAliasPersonalizations;
    }

    public void setRecipientAliasPersonalizations(List<PersonalizationInformation> recipientAliasPersonalizations) {
        this.recipientAliasPersonalizations = recipientAliasPersonalizations;
    }

    @XmlElementWrapper(name="htmlPersonalizations")
    @XmlElement(name = "item", type=Personalization.class)
    public List<PersonalizationInformation> getHtmlPersonalizations() {
        return htmlPersonalizations;
    }

    public void setHtmlPersonalizations(List<PersonalizationInformation> htmlPersonalizations) {
        this.htmlPersonalizations = htmlPersonalizations;
    }

    @XmlElementWrapper(name="textPersonalizations")
    @XmlElement(name = "item", type=Personalization.class)
    public List<PersonalizationInformation> getTextPersonalizations() {
        return textPersonalizations;
    }

    public void setTextPersonalizations(List<PersonalizationInformation> textPersonalizations) {
        this.textPersonalizations = textPersonalizations;
    }

    @XmlElement
    public long getMailingId() {
        return mailingId;
    }

    public void setMailingId(long mailingId) {
        this.mailingId = mailingId;
    }

    @XmlElement
    public Date getTimestamp() {
        return timestamp;
    }

    public void setTimestamp(Date timestamp) {
        this.timestamp = timestamp;
    }

    @XmlElement
    public String getState() {
        return state;
    }

    public void setState(String state) {
        this.state = state;
    }
}
