package com.maileon.api.mailings.checks;

import java.io.Serializable;
import java.util.Date;
import java.util.List;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

/**
 * Result for Spam Quality Check
 */
@XmlRootElement(name="SpamCheck")
@XmlType(propOrder={"mailingId", "timestamp", "state", "results"})
public class SpamCheckResult implements Serializable {

    private long mailingId;

    private Date timestamp;

    private String state;

    private List<SpamCriterionlResult> results;

    @Override
    public String toString() {
        String ret = "mailingId: " + mailingId + ", timestamp: " + timestamp + ", state: " + state;
        ret += "\nResults{";
        for (SpamCriterionlResult r : results) {
            ret += r.toString();
        }
        ret += "}";
        return ret;
    }

    @XmlElementWrapper(name="results")
    @XmlElement(name="item", type=SpamCriterionlResult.class)
    public List<SpamCriterionlResult> getResults() {
        return results;
    }

    public void setResults(List<SpamCriterionlResult> results) {
        this.results = results;
    }

    @XmlElement
    public long getMailingId() {
        return mailingId;
    }

    public void setMailingId(long mailingId) {
        this.mailingId = mailingId;
    }

    @XmlElement
    public Date getTimestamp() {
        return timestamp;
    }

    public void setTimestamp(Date timestamp) {
        this.timestamp = timestamp;
    }

    @XmlElement
    public String getState() {
        return state;
    }

    public void setState(String state) {
        this.state = state;
    }
}
